//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "GeomFigur_u.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;


// #include "Kl_GeomFigur.h"
#include "Quadrat.h"
#include "Kreis.h"
#include "Dreieck.h"
// Lcke


#define MAX_ANZ 100
GeomFigur *figur[100];
GeomFigur *backup[100];
int fNr = 0, backup_fNr;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner) : TForm(Owner){
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  zeichenflaeche->Canvas->Brush->Color = clWhite;
  zeichenflaeche->Canvas->FillRect(Rect(0, 0, zeichenflaeche->Width,
                                              zeichenflaeche->Height));
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnLoeschenClick(TObject *Sender)
{
  int i;
  zeichenflaeche->Canvas->FillRect(Rect(0, 0, zeichenflaeche->Width,
                                              zeichenflaeche->Height));
  for (i = 0; i < backup_fNr; i++)
     delete backup[i];         // letzte Sicherung lschen

  for (i = 0; i < fNr; i++)
     backup[i] = figur[i];     // Zeiger der Instanzen, die 
                               // "gelscht" werden, kopieren
  backup_fNr = fNr;            // Anzahl der "gelschten" Instanzen merken	

  fNr = 0;                     // Das Feld figur[ ] ist jetzt leer!
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnZeichneClick(TObject *Sender)
{
  int x, y, breite, hoehe, auswahl;
    try
      {
      x = StrToInt(edtX->Text);
      y = StrToInt(edtY->Text);
      breite = StrToInt(edtBreite->Text);
      if (edtHoehe->Text != "")
          hoehe = StrToInt(edtHoehe->Text);
      else
          hoehe = -1;      // falls kein Wert fr Hhe eingegeben wurde
      auswahl = rbgFigur->ItemIndex;
      if (auswahl != -1 && (auswahl != 1 && auswahl != 3 || hoehe != -1))
         {                             // Falls Rechteck oder Dreieck gewhlt
                                       // ist, muss die Hoehe bestimmt sein.
         switch (auswahl)
             {
             case 0: figur[fNr] = new Kreis(x, y, breite);
                     break ;
             case 1: figur[fNr] = new Rechteck(x, y, breite, hoehe);
                     break;
             case 2: figur[fNr] = new Quadrat(x, y, breite);
                     break;
             case 3: figur[fNr] = new Dreieck(x, y, breite, hoehe);
                     break;


             }
         figur[fNr]->zeichne(zeichenflaeche);

         if (fNr < MAX_ANZ)
             fNr++;
         }
      else
         ShowMessage("Eingabe unvollstndig");
      }
     catch (Exception &exception)
      {
      ShowMessage("    Eingabefehler    ");
      }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnWiderrufenClick(TObject *Sender)
{
  int i;
  if (fNr == 0)
      {
      fNr = backup_fNr;          // Anzahl der GeomFigur-Elemente
      for (i = 0; i < fNr; i++)
          {
          figur[i] = backup[i];  // Zeiger der "gelschten" Instanzen kopieren
          figur[i]->zeichne(zeichenflaeche);
          }
      backup_fNr = 0;            // Das Feld backup[ ] ist jetzt leer!



      }
  else
     ShowMessage("Widerrufen ist nicht mehr mglich!");
}
//---------------------------------------------------------------------------


